<?php

require PHPTAL_DIR.'PHPTAL/Php/State.php';
require PHPTAL_DIR.'PHPTAL/Php/CodeWriter.php';

/**
 * @package phptal.php
 */
class PHPTAL_Php_CodeGenerator
{
    public function __construct($function_name, $source_path, $enc, $mode, $cachepath)
    {
        $this->_functionName = $function_name;
        $this->_sourceFile = $source_path;
        $this->_state = new PHPTAL_Php_State();
        $this->_state->setEncoding($enc);
        $this->_state->setCacheFilesBaseName($cachepath);
        $this->_state->setOutputMode($mode);
    }


    public function generate(PHPTAL_DOMElement $treeGen)
    {   
        $codewriter = new PHPTAL_Php_CodeWriter($this->_state);

        $codewriter->doComment("\n*** DO NOT EDIT THIS FILE ***\n\nGenerated by PHPTAL from ".$this->_sourceFile." (edit that file instead)");
        $codewriter->doFunction($this->_functionName, '$tpl, $ctx');
        $codewriter->setFunctionPrefix($this->_functionName . "_");
        $codewriter->doSetVar('$_thistpl', '$tpl');
        $codewriter->doSetVar('$glb', '$tpl->getGlobalContext()');
        $codewriter->doSetVar('$_translator', '$tpl->getTranslator()');
        $treeGen->generate($codewriter);
        $codewriter->doEnd();
        
        return $codewriter->getResult();
    }

    private $_functionName;
    private $_sourceFile;
    private $_state;
}

